function lambda_hat = est_lambdav2(const,phi,sigma,T,seed,nsim, phihatvec, nirf_rest, nirf)

if phi ~= zeros(size(phi,1),size(phi,2)) %if it is a VAR(1)
l = ones(T-1,1);
M_l = eye(T-1) - l*inv(l'*l)*l';
elseif phi == zeros(size(phi,1),size(phi,2)); %if it is a VAR(0)
l = ones(T,1);
M_l = eye(T) - l*inv(l'*l)*l';    
end


n_sim = 2; %needed as input for gdp_VAR

for j=1:nsim
    yysim = gdp_VAR(const,phi,sigma,T,seed,n_sim);
    if phi ~= zeros(size(phi,1),size(phi,2))
        ysim = yysim(2:T,:);
        y_1sim = yysim(1:T-1,:);
        phihat = ysim'*y_1sim*inv(y_1sim'*y_1sim);
        residsim = ysim - y_1sim*phihat';
        sigmahatsim = residsim'*M_l*residsim/(T-2);
        
        sigmaLhatsim = chol(sigmahatsim,'lower');
        
        YYirf = estimate_irfs(phihat,sigmaLhatsim, nirf);
        R1hatsim  = YYirf(1:nirf_rest,:); % Reduced form impulse response that are sign restricted or part of theta
        temp = reshape(R1hatsim',size(YYirf,1)*size(YYirf,2),1);
        phihatsim(j,:) = [temp(1,1);temp(3:end,1)]; %take out the zero element from the impact IRF
        lag = 1;
   
    end
end

phi_hat_sim = phihatsim - kron(ones(nsim,1),phihatvec');
lambda_hat = (T-lag-1)*phi_hat_sim'*phi_hat_sim/nsim;