
% /* This procedure generates impulse responses for all variables to all
% shocks and horizon up to nirf

function [YYirf] = estimate_irfs(phi, Sigmatr, nirf);
nvar      =   size(phi,1);
nlags     =   floor(size(phi,2)/nvar);

% /* Compute Impulse Responses
% ** Format:
% ** h=1: (sh1 -> v1) (sh1 -> v2) (sh2 -> v1) (sh2 -> v2) 
% ** h=2: (sh1 -> v1) (sh1 -> v2) (sh2 -> v1) (sh2 -> v2) 
% */
YYirf  = zeros(nirf,nvar^2);
temp = zeros(nvar,nvar);

for j = 1:nirf
    if j ==1
    temp = phi*temp + Sigmatr;
    else
    temp = phi*temp;
    end
  YYirf(j,:) = reshape(temp,1,nvar^2);  
end
% 
MM = zeros(nvar^2,nvar^2);
IdentityMatrix = eye(nvar);

for i =1:nvar;
   MM(1+(i-1)*nvar:i*nvar,:) = kron(IdentityMatrix,IdentityMatrix(i,:));
end
% % 
% % % /* Reorder Impulse Responses
% % % ** h=1: (sh1 -> v1) (sh2 -> v1) (sh1 -> v2) (sh2 -> v2) 
% % % ** h=2: (sh1 -> v1) (sh2 -> v1) (sh1 -> v2) (sh2 -> v2) 
% % % */
YYirf = YYirf*MM;
% 

