%%%%%%%% generate an Txndim vector of data from a VAR(1) model with dynamic coefficient phi 
function [Y]= gdp_VAR1(const,phi,Sigma,T,seed,s);

% This program generate VAR(1) Gaussian Time series of size T and error
% covariance "sigma", the VAR(1) coefficient "phi"

    ndim=size(phi,1); % the dimension of var
    if s==1
    randn('state',seed);  % normal random number generator uses fixed starting value
    end
    v = randn((T+200),ndim);   % generation of normally distributed TxN matrix of N(0,I) errors  
    SigmaL = chol(Sigma,'lower');
    e = v*SigmaL';  % generate a TxN matrix of errors 
    Y0 = zeros(1,ndim);
    Y = [];
    Y = [Y;Y0];
    for t = 1:(T+200);
      Yt_1 = Y(t,:);
      Yt = const + Yt_1*phi' + e(t,:);
      Y = [Y;Yt];
    end    
    Y = Y(202:T+201,:); %take out the first 200 draws which were used for initialization
    
end
   