function [idset, idq, qbinary] = setestimator(phi, angle)

% This is to compute the idenfied set or estimate of the identified set, 
% depending on this input. works if we have a bivariate VAR and if theta is
% scalar
% phi is the reduced form parameter

n_grid = size(angle,2);
m = size(phi,1);
nvar = 2; %bivariate case, q=[q1 q2]

idtheta = [];
idq = [];
qbinary = zeros(1,n_grid);

for i = 1:n_grid,
   q1 = cos(angle(1,i));
   q2 = sin(angle(1,i));
   
   theta = [q1, zeros(1,m-1)]*phi;
   mu = [zeros((m-1)/nvar,1),kron(eye((m-1)/nvar),[q1 q2])]*phi;

    if (theta >= 0) && sum(mu >=0)==size(mu,1)
        idtheta = [idtheta;theta];
        idq = [idq, angle(1,i)];
        qbinary(1,i) = 1;
    end    
   
end

idtheta = sort(idtheta);
empty = isempty(idtheta);
if empty ==1
 idset =[0;0];
elseif empty==0
 idset = [idtheta(1,1) ;idtheta(end,1)];   % identified set for theta 
end

