function [CSB_O, CSB_I,CSq_O, CSq_I,arc_O,arc_I, bind_q] = cs_gis(stepsize,lambdahat,phihat, T,  kappaT, cvB1, cvB2, Z3, alpha1)

%set-up for minim problem
Aeq = [];
beq = [];
lb = [];
ub = [];
nonlcon = [];
options = optimset('Display', 'off') ;


phihat1 = phihat(1,1);
phihat2 = phihat(2,1);
phihat3 = phihat(3,1);

 angle = [-pi/2 : stepsize : pi/2];
 rr = 1;  %initialize counter for Bonferroni step one CI when Bhat is inverse of Omega
 ll = 1; %initialize counter for Bonferroni step one CI when Bhat is identity
 bind_q = zeros(1, size(angle,2));
 
  for gg = 1:size(angle,2) %loop over angle
       
   q1 = cos(angle(1,gg));
   q2 = sin(angle(1,gg));
   
     if abs(angle(1,gg))== pi/2 %to avoid singularity of (Sq*lambdahat*Sq')

        Sigma = [ 0 q1 q2]*lambdahat*[ 0 q1 q2]'; %matrix Stilda_q on page 10 NBER wp when q1 is zero;
        D = diag(diag(Sigma));
        Omega = diag(diag(D).^(-1/2))*Sigma*diag(diag(D).^(-1/2));
        
            BhatO = inv(Omega);     
            BhatI = eye(size(Sigma,1));
            
        %%%% compute objective function
            if q1*phihat2 + q2*phihat3 >=0 
                Q_RO(1,gg) = 0; 
                Q_RI(1,gg) = 0; 
            else
                Q_RO(1,gg) = BhatO*T*(q1*phihat2 + q2*phihat3)^2 ;  
                Q_RI(1,gg) = BhatI*T*(q1*phihat2 + q2*phihat3)^2 ;  
            end
        
        %%%%compute critical value
        csi2 = (1/sqrt(Sigma))*sqrt(T)*(q1*phihat2 + q2*phihat3); 
           if csi2 < kappaT
             cvO(1,gg) = cvB1;
             cvI(1,gg) = cvB1;
             bind_q(1,gg) = 1;
           elseif csi2 >= kappaT
             cvO(1,gg) = 0;
             cvI(1,gg) = 0;
           end
     else %if there is no rank reduction issue
        Sigma = [ q1 0 0 ;0 q1 q2]*lambdahat*[ q1 0 0 ;0 q1 q2]';    
        D = diag(diag(Sigma));
        Omega = diag(diag(D).^(-1/2))*Sigma*diag(diag(D).^(-1/2));
            
        BhatO = inv(Omega); 
        BhatI = eye(size(Sigma,1));
      
              
        %%%% compute objective function
        Z = [q1*phihat1;q1*phihat2 + q2*phihat3];
        
            if Z>=0
                muO = Z;
                muI = Z;
            else        
               [muO]= fmincon(@(muO)(T*( diag(diag(D).^(-1/2))*(Z-muO))'*BhatO*( diag(diag(D).^(-1/2))*(Z-muO))),[Z],-eye(2),[0,0]', Aeq,beq,lb,ub,nonlcon,options);
                muI = (Z>=0).*Z;
            end
        
            Q_RO(1,gg) = T*( diag(diag(D).^(-1/2))*(Z-muO))'*BhatO*( diag(diag(D).^(-1/2))*(Z-muO));
            Q_RI(1,gg) = T*( diag(diag(D).^(-1/2))*(Z-muI))'*BhatI*( diag(diag(D).^(-1/2))*(Z-muI));
        
        %%%%compute critical value
        csi1 = (1/sqrt(Sigma(1,1)))*sqrt(T)*(q1*phihat1);
        csi2 = (1/sqrt(Sigma(end,end)))*sqrt(T)*(q1*phihat2 + q2*phihat3);
        
        L = chol(lambdahat, 'lower');
        if csi1 < kappaT && csi2 < kappaT
             
            bind_q(1,gg) = 2;
              for ss = 1:size(Z3,2)
         
                A = diag(diag(D).^(-1/2))*[q1 0 0 ; 0 q1 q2]*L*Z3(:,ss); % first term in the minimization problem
                
                if A>=0
                    uO =A;
                    uI =A;
                else
                         
                uO = fmincon(@(uO)((A-uO)'*BhatO*(A-uO)),[0,0]',-eye(2),[0,0]'); 
                uI = (A>=0).*A;

                end
                GbarO(1,ss) = (A-uO)'*BhatO*(A-uO);
                GbarI(1,ss) = (A-uI)'*BhatI*(A-uI);
              end
              cvO(1,gg)= prctile(GbarO,(1-alpha1)*100); 
              cvI(1,gg)= prctile(GbarI,(1-alpha1)*100); 
             
          elseif csi1 < kappaT && csi2 >= kappaT
              bind_q(1,gg) = 1;  
              cvO(1,gg) = cvB1;
              cvI(1,gg) = cvB1;
            
          elseif csi1 >= kappaT && csi2 < kappaT
              bind_q(1,gg) = 1;
              cvO(1,gg) = cvB1;
              cvI(1,gg) = cvB1;
              
          elseif csi1 >= kappaT && csi2 >= kappaT
            
              cvO(1,gg) = 0;
              cvI(1,gg) = 0;
              
        end
     end %end of if for abs(angle) = pi/2

    if Q_RO(1,gg) - cvO(1,gg)<=0  %construct the confidence set CS_gis,1-alpha1
      CSO(1,rr) = max(0,q1*phihat1-q1*cvB2*sqrt(lambdahat(1,1)/T));  
      CSO(2,rr) = q1*phihat1 + q1*cvB2*sqrt(lambdahat(1,1)/T);
      CSqO(1,rr)= q1;
      arcO(1,rr) = angle(1,gg);
      rr = rr+1;
    end
    
    if Q_RI(1,gg) - cvI(1,gg)<=0  %construct the confidence set for q CSqI and the conditional CS for theta, CSI
      CSI(1,ll) = max(0,q1*phihat1-q1*cvB2*sqrt(lambdahat(1,1)/T));  
      CSI(2,ll) = q1*phihat1 + q1*cvB2*sqrt(lambdahat(1,1)/T);
      CSqI(1,ll)= q1;
      arcI(1,ll) = angle(1,gg);
      ll = ll+1;
    end

  end  %end of loop over angle
  
CSB_O = [min(CSO(1,:));max(CSO(2,:))]; %construct CS for theta
CSB_I = [min(CSI(1,:));max(CSI(2,:))]; %construct CS for theta

CSq_O = max(CSqO);
CSq_I = max(CSqI);

arc_O = [min(arcO);max(arcO)];
arc_I = [min(arcI);max(arcI)];


