function [idset] = setestimator(phi)

% This is to compute the idenfied set or estimate of the identified set, 
% depending on this input. 
% phi is the reduced form parameter
% gridleng is the grid size for grid search
gridleng = 0.0001;
grid_q = [-1:gridleng:1];

n_grid = size(grid_q,2);

idtheta = [];

for i = 1:n_grid,
    q1 = grid_q(1,i);
    q21 = sqrt(1-q1^2);
    q22 = -q21;


    theta1 = [q1 q21 0 0]*phi;
    mu1 = [0 0 q1 q21]*phi;
    theta2 = [q1 q22 0 0]*phi;
    mu2 = [0 0 q1 q22]*phi;


    if (theta1 >= 0) && (mu1 >=0)
        idtheta = [idtheta;theta1];
    end
    
    if (theta2 >= 0) && (mu2 >=0)
        idtheta = [idtheta;theta2];
    end
end

idtheta = sort(idtheta);
idtheta_l = idtheta(1,1);
n_idtheta = size(idtheta,1);
idtheta_h = idtheta(n_idtheta,1);
idset = [idtheta_l ;idtheta_h];   % identified set for theta 



