%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% THIS CODE PLOTS FIGURE 3 and 4 IN THE PAPER: 
% INFERENCE FOR VARs IDENTIFIED WITH SIGN RESTRICTIONS By Eleonora Granziera
% Hyungsik Roger Moon and Frank Schorfheide (2017)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load('figure3_EXAnobs170Nsim5000.mat')
%theta_coveu_1: upper bound, 1 is the significance level of the CI for q

nirf = size(theta_coveu_1,1);
x_horizon = [0:1:nirf-1];
alpha = 0.1;

%%%%%%%%%%%%%   FIGURE 3 TOP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fig = figure('Name','Figure 3: Top');
fig3_var1cov =  plot( x_horizon, theta_coveu_1(:,1), 'g-->' ,x_horizon, theta_covel_1(:,1), 'g->',...
    x_horizon, theta_coveu_5(:,1), 'b--', x_horizon, theta_covel_5(:,1), 'b',...
    x_horizon, theta_coveu_9(:,1), 'r--o', x_horizon, theta_covel_9(:,1), 'r-o',...
    x_horizon, ones(nirf,1)*(1-alpha), 'k', 'LineWidth', 3);
axis([0,nirf-1,0.85,1.01])
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'exp3A_var1cov.pdf' ];
saveas(fig, savefilename);

fig = figure('Name','Figure 3: Top');
fig3_var2cov = plot( x_horizon, theta_coveu_1(:,2), 'g-->', x_horizon, theta_covel_1(:,2), 'g->',...
    x_horizon, theta_coveu_5(:,2), 'b--', x_horizon, theta_covel_5(:,2), 'b',...
    x_horizon, theta_coveu_9(:,2), 'r--o', x_horizon, theta_covel_9(:,2), 'r-o',...
    x_horizon, ones(nirf,1)*(1-alpha), 'k','LineWidth', 3);
axis([0,nirf-1,0.85,1.01])
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'exp3A_var2cov.pdf' ];
saveas(fig, savefilename);


%%%%%%%%%%%%%   FIGURE 3 BOTTOM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fig = figure('Name','Figure 3: Bottom');
fig3_var1width =  plot( x_horizon, theta_width_1(:,1), 'g->',...
    x_horizon, theta_width_5(:,1), 'b',...
    x_horizon, theta_width_9(:,1), 'r-o',...
    x_horizon, length_id(:,1), 'k-x','LineWidth', 3);
axis([0,nirf-1,0.4,1.8])
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'exp3A_var1width.pdf' ];
saveas(fig, savefilename);

fig = figure('Name','Figure 3: Bottom');
fig3_var2width = plot( x_horizon, theta_width_1(:,2),  'g->',...
    x_horizon, theta_width_5(:,2),  'b',...
    x_horizon, theta_width_9(:,2),  'r-o',...
    x_horizon, length_id(:,2), 'k-x','LineWidth', 3);
axis([0,nirf-1,0.2,1.25])
legend('\alpha_1 = 0.01', '\alpha_1 = 0.05', '\alpha_1 = 0.09')
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'exp3A_var2width.pdf' ];
saveas(fig, savefilename);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load('figure3_EXCnobs170Nsim5000.mat')


%%%%%%%%%%%%%   FIGURE 4 TOP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fig = figure('Name','Figure 4: Top');
fig3_var1cov = plot( x_horizon, theta_coveu_5(:,1), 'b--', x_horizon, theta_covel_5(:,1), 'b',...
    x_horizon, theta_coveu_10(:,1), 'g-->', x_horizon, theta_covel_10(:,1), 'g->',...
    x_horizon, theta_coveu_15(:,1), 'r--o', x_horizon, theta_covel_15(:,1), 'r-o',...
    x_horizon, ones(nirf,1)*(1-alpha), 'k', 'LineWidth', 3);
axis([0,nirf-1,0.82,1.01])
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'exp3C_var1cov.pdf' ];
saveas(fig, savefilename);

fig3_var1cov = plot( x_horizon, theta_coveu_5(:,2), 'b--', x_horizon, theta_covel_5(:,2), 'b',...
    x_horizon, theta_coveu_10(:,2), 'g-->', x_horizon, theta_covel_10(:,2), 'g->',...
    x_horizon, theta_coveu_15(:,2), 'r--o', x_horizon, theta_covel_15(:,2), 'r-o',...
    x_horizon, ones(nirf,1)*(1-alpha), 'k','LineWidth', 3);
axis([0,nirf-1,0.82,1.01])
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'exp3C_var2cov.pdf' ];
saveas(fig, savefilename);

%%%%%%%%%%%%%   FIGURE 4 BOTTOM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fig = figure('Name','Figure 4: Bottom');
fig3_var1width = plot( x_horizon, theta_width_5(:,1), 'b',...
    x_horizon, theta_width_10(:,1), 'g->',...
    x_horizon, theta_width_15(:,1), 'r-o',...
    x_horizon,length_id(:,1),'k-x','LineWidth', 3);
axis([0,nirf-1,0.4,1.8])
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'exp3C_var1width.pdf' ];
saveas(fig, savefilename);

fig = figure('Name','Figure 3: Bottom');
fig3_var2width = plot( x_horizon, theta_width_5(:,2),  'b',...
    x_horizon, theta_width_10(:,2),  'g->',...
    x_horizon, theta_width_15(:,2),  'r-o',...
    x_horizon, length_id(:,2),'k-x','LineWidth', 3);
axis([0,nirf-1,0.2,1.25])
legend('\alpha_2 = 0.05', '\alpha_2 = 0.10', '\alpha_2 = 0.15')
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'exp3C_var2width.pdf' ];
saveas(fig, savefilename);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 