function [ q_cove,   n_binding,  cv, obj_all] = construct_qcs( q_grid, Lambda_hat, psi_hat, signrestrictionsindx, index_phi, nobs, nsim_cv, tau_q )

                                                                                          
% This function constructs the CS for q
% Define some constants 
q_dim = size(q_grid,2); %size of grid of q:
nvar  = size(q_grid,1);


q_cove = zeros(1,q_dim);
n_binding = zeros(1,q_dim);
cv = zeros(1,q_dim);
obj_all = zeros(1,q_dim);

% For each q in q_grid, check whether the obj is less than critical value
for q_ind = 1:q_dim
    q = q_grid(:,q_ind);
    
    [GT_val, critval, n_bind, is_binding] = GTobjconc(q, Lambda_hat, psi_hat, ...
        signrestrictionsindx(:,3), index_phi, nobs, nsim_cv, tau_q);
    
   
    n_binding(1,q_ind) = n_bind;
    obj_all(1,q_ind) = GT_val;
    cv(1,q_ind) = critval;

    
    if GT_val <= critval; %q is included in the cs
        q_cove(1,q_ind) = 1;
    end
    
        
end

end

