function [ fcn , critval,  n_binding, is_binding] = GTobjconc( q, lambda_hat, ...
           psi_hat,YYirfrestr , index_phi, nobs, nsim_cv, tauq)
% Some Definitions
mu_dim    = size(YYirfrestr,1);
q_dim     = size(q,1);
Sq        = kron(eye(mu_dim),q');
Sq        = Sq(:,index_phi);

% Sigma and its factorization: Sigma = Dsqrt*Omega*Dsqrt
Sigma     = Sq*lambda_hat*Sq';
Dsqrt     = sqrt(diag(Sigma));
Dsqrt_inv = inv(diag(Dsqrt));
Omega     = Dsqrt_inv*Sigma*Dsqrt_inv;

%  Weight Matrix
W         = Dsqrt_inv*Dsqrt_inv;

% (Trivial) Solution to quadratic programming problem
csi_hat   = (Sq*psi_hat).*YYirfrestr;
mu_hat    = csi_hat .*(csi_hat >= 0 );

% % compute objective function

delta     = csi_hat - mu_hat;
fcn       = nobs*delta'*W*delta; %the objective function includes all the R conditions with negative csi_hat 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% determine the binding moment conditions
csi_hat     = sqrt(nobs)*csi_hat.*diag(Dsqrt_inv);
is_binding  = csi_hat <= 1.96*log(log(nobs));
n_binding   = sum(is_binding);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Simulated Critical Value
% Only use elements of Omega that correspond to binding moment conditions
if n_binding > 0;
   % keep only binding moment conditions 
   [critval]= cv_bonf(tauq, Omega,is_binding, nsim_cv,  q_dim);  % AS 
   
else
   % no moment condition is binding
   % 1E-10 is also used as cutoff for identified set
   critval = 1E-10;
end

%disp([fcn,critval])

end

