%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot Figure (6) in:
% 
% INFERENCE FOR VARs IDENTIFIED WITH SIGN RESTRICTIONS
%
% by Eleonora Granziera, Hyungsik Roger Moon and Frank Schorfheide (2017)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all

load('figure6row2.mat')
%theta_coveu_1: upper bound, 1 is the significance level of the CI for q

nirf = size(IShigh,1);
x_horizon = [0:1:nirf-1];

%%%%%%%%%%%%%   FIGURE 6 MIDDLE PANEL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fig = figure('Name','Figure 6: Var 1 Row 2');
fig6_var1 =  plot( x_horizon, CShigh_alpha5(:,1), 'b--' ,x_horizon,  CSlow_alpha5(:,1), 'b',...
    x_horizon, CShigh_alpha10(:,1), 'g-->', x_horizon, CSlow_alpha10(:,1), 'g->',...
    x_horizon, IShigh(:,1), 'k--x', x_horizon, ISlow(:,1),  'k-x',...
    x_horizon, zeros(nirf,1), 'k', 'LineWidth', 3);
xlim([0 nirf-1]);
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'fig_6row2var1.pdf' ];
saveas(fig, savefilename);

fig = figure('Name','Figure 6: Var 2 Row 2');
fig6_var2 =  plot(         x_horizon,  CSlow_alpha5(:,2), 'b',...
    x_horizon, CSlow_alpha10(:,2), 'g->',...
    x_horizon, CShigh_alpha5(:,2), 'b--' ,  x_horizon, CShigh_alpha10(:,2), 'g-->',...
    x_horizon, IShigh(:,2), 'k--x', x_horizon, ISlow(:,2),  'k-x',...
    x_horizon, zeros(nirf,1), 'k', 'LineWidth', 3);
xlim([0 nirf-1]);
legend('\alpha_2 = 0.05', '\alpha_2 = 0.1','Location','southeast')
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'fig_6row2var2.pdf' ];
saveas(fig, savefilename);

clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load('figure6row3.mat')

nirf = size(IShigh,1);
x_horizon = [0:1:nirf-1];


%%%%%%%%%%%%%   FIGURE 6 BOTTOM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fig = figure('Name','Figure 6: Var 1 Row 3');
fig6_var1 =  plot(x_horizon,  CSlow_alpha5(:,1), 'b',...
    x_horizon, CSlow_alpha10(:,1), 'g->',...
    x_horizon, CShigh_alpha5(:,1), 'b--' ,...
    x_horizon, CShigh_alpha10(:,1), 'g-->', ...
    x_horizon, IShigh(:,1), 'k--x', x_horizon, ISlow(:,1),  'k-x',...
    x_horizon, zeros(nirf,1), 'k', 'LineWidth', 3);
xlim([0 nirf-1]);
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'fig_6row3var1.pdf' ];
saveas(fig, savefilename);

fig = figure('Name','Figure 6: Var 2 Row 3 ');
fig6_var2 =  plot(x_horizon,  CSlow_alpha5(:,2), 'b',...
    x_horizon, CSlow_alpha10(:,2), 'g->',...
    x_horizon, CShigh_alpha5(:,2), 'b--' ,...
    x_horizon, CShigh_alpha10(:,2), 'g-->', ...
    x_horizon, IShigh(:,2), 'k--x', x_horizon, ISlow(:,2),  'k-x',...
    x_horizon, zeros(nirf,1), 'k', 'LineWidth', 3);
xlim([0 nirf-1]);
legend('\alpha_2 = 0.05', '\alpha_2 = 0.1','Location','southeast')
set(gca,'FontSize',28,'FontWeight','Bold')
savefilename = [ 'fig_6row3var2.pdf' ];
saveas(fig, savefilename);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 