function [ XXinp ] = construct_regressors( YY, nlags, intercept )
% Estimate reduced form parameters for a VAR(p) with nvar variables 

% Turn VAR into Y = XBeta+U
nobs  = size(YY, 1);
nvar  = size(YY, 2);
YYinp = YY(nlags+1:end,:);
XXinp = [];

for p = 1:nlags
    XXinp = [YY(p:end-nlags+p-1 ,:),XXinp];
end;

if intercept ==1
 XXinp = [XXinp, ones(size(XXinp,1),1)];   
end;

end
