% function to compute the cv for the Bonferroni confidence set of q. 

function [cv_AS] = cv_bonf(alpha1, Omega,is_binding, nsim_cv, q_dim);

rng(123456);
n_restr     = size(Omega,1);
Omega_chol = chol(Omega,'lower');
Zm         = Omega_chol*randn(n_restr,nsim_cv);
Zm_binding = Zm(is_binding,:); 


%%%%%%   For AS procedure  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ZmAS = Zm_binding;% Solve quadratic programming problem
    nu_hatAS = ZmAS .* (ZmAS >= 0);

    deltaAS = ZmAS - nu_hatAS;% Compute objective function
    GqAS = sum( deltaAS.^2, 1 )';

cv_AS = prctile(GqAS,(1-alpha1)*100);% Compute critical value

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%







