function [ phi_mle, sigma_mle ] = estimate_rfvar( YY, nlags, intercept )
% Estimate reduced form parameters for a VAR(p) with nvar variables 

% Turn VAR into Y = XBeta+U
nobs  = size(YY, 1);
nvar  = size(YY, 2);
YYinp = YY(nlags+1:end,:);
XXinp = [];

for p = 1:nlags
    XXinp = [YY(p:end-nlags+p-1 ,:),XXinp];
end;

if intercept ==1
 XXinp = [XXinp, ones(size(XXinp,1),1)];   
end;

% Estimate the reduced form parameters phi_mle and sigma_mle
phi_mle     = (inv(XXinp'*XXinp))*(XXinp'*YYinp) ; %[A1;A2;...Ap;intercept]
sigma_mle   = (1/nobs)*((YYinp-XXinp*phi_mle)'*(YYinp-XXinp*phi_mle)); 
sigmatr_mle = chol(sigma_mle,'lower'); 

end

